Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtPreprocessorThread.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtPreprocessorThread.h	(revision 1947)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtInterface/QtPreprocessorThread.h	(revision 2608)
@@ -2,5 +2,5 @@
 #define __QT_PREPROCESSOR_THREAD_H
 
-//#ifdef USE_QT
+#ifdef USE_QT
 
 #include <QThread>
@@ -35,4 +35,4 @@
 }
 
-//#endif
 #endif
+#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2606)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2608)
@@ -526,4 +526,7 @@
   #maxDepthAllowed 22
   #maxListLength    6
-}
-
+  # For Power plant
+  #maxDepthAllowed 8
+  #maxListLength    10
+}
+
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2606)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2608)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 17. I 15:26:52 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 17. I 17:18:38 2008
 # Project:  preprocessor.pro
 # Template: app
@@ -71,7 +71,4 @@
 		C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf \
 		C:\Qt\4.1.2\mkspecs\features\default_post.prf \
-		C:\Qt\4.1.2\mkspecs\features\qt.prf \
-		C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf \
-		C:\Qt\4.1.2\mkspecs\features\moc.prf \
 		C:\Qt\4.1.2\mkspecs\features\win32\thread.prf \
 		C:\Qt\4.1.2\mkspecs\features\warn_off.prf \
@@ -92,7 +89,4 @@
 C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf:
 C:\Qt\4.1.2\mkspecs\features\default_post.prf:
-C:\Qt\4.1.2\mkspecs\features\qt.prf:
-C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf:
-C:\Qt\4.1.2\mkspecs\features\moc.prf:
 C:\Qt\4.1.2\mkspecs\features\win32\thread.prf:
 C:\Qt\4.1.2\mkspecs\features\warn_off.prf:
@@ -116,16 +110,4 @@
 distclean: release-distclean debug-distclean FORCE
 	-$(DEL_FILE) Makefile
-
-release-mocclean: $(MAKEFILE).Release
-	$(MAKE) -f $(MAKEFILE).Release mocclean
-debug-mocclean: $(MAKEFILE).Debug
-	$(MAKE) -f $(MAKEFILE).Debug mocclean
-mocclean: release-mocclean debug-mocclean
-
-release-mocables: $(MAKEFILE).Release
-	$(MAKE) -f $(MAKEFILE).Release mocables
-debug-mocables: $(MAKEFILE).Debug
-	$(MAKE) -f $(MAKEFILE).Debug mocables
-mocables: release-mocables debug-mocables
 FORCE:
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2603)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2608)
@@ -173,4 +173,5 @@
 	}
 
+	
 	Environment::GetSingleton()->GetStringValue("Scene.filename", buff);
 	string filename(buff);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktbf2trv.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktbf2trv.cpp	(revision 2595)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktbf2trv.cpp	(revision 2608)
@@ -413,5 +413,7 @@
 // This code allows to specify the box where the ray should be traversed!
 void
-CKTBTraversal::FindNearestI(RayPacket2x2 &rp, Vector3 &boxmin, Vector3 &boxmax)
+CKTBTraversal::FindNearestI(RayPacket2x2 &rp,
+							const Vector3 &boxmin,
+							const Vector3 &boxmax)
 {
   static AxisAlignedBox3 localbox;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktball.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktball.cpp	(revision 2603)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktball.cpp	(revision 2608)
@@ -424,5 +424,7 @@
 
 void
-CKTB::FindNearestI(RayPacket2x2 &raypack, Vector3 &boxmin, Vector3 &boxmax)
+CKTB::FindNearestI(RayPacket2x2 &raypack,
+				   const Vector3 &boxmin,
+				   const Vector3 &boxmax)
 {
   if (!makeMinBoxes)
Index: GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktball.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktball.h	(revision 2602)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktball.h	(revision 2608)
@@ -16,4 +16,5 @@
 // GOLEM headers
 #include "configh.h"
+#include "ktbconf.h"
 //#include "ktbi.h"
 #include "ktbai.h"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/havran/configh.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/havran/configh.h	(revision 2602)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/havran/configh.h	(revision 2608)
@@ -13,4 +13,12 @@
 #ifndef __CONFIGH_H__
 #define __CONFIGH_H__
+
+#if defined(_MSC_VER)
+// use perftimer only on msvc
+// define __SSE__ macro as it is not defined under MSVC
+#define __SSE__
+// If we support the use of SSE instructions for ray shooting
+#define _USE_HAVRAN_SSE
+#endif
 
 #ifndef USE_GOLEM_NAMESPACE
Index: GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktbconf.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktbconf.h	(revision 2603)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/havran/ktbconf.h	(revision 2608)
@@ -23,6 +23,4 @@
 #endif
 
-// If we support the use of SSE instructions for ray shooting
-// #define _USE_HAVRAN_SSE
 
 namespace GtpVisibilityPreprocessor {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pompeii
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pompeii	(revision 2607)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pompeii	(revision 2608)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!sh
 
 
@@ -16,5 +16,5 @@
 VIEWCELLS=../data/Pompeii/pompeii_big-seq-viewcells.xml.gz
 
-PREFIX=../work/plots/osp-pompeii-SG08a
+PREFIX=../work/plots/osp-pompeii-SG08dummy
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_powerplant
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_powerplant	(revision 2607)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_powerplant	(revision 2608)
@@ -1,6 +1,6 @@
-#!/bin/sh
+#!sh
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -total_samples=500000000"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -total_samples=500000000 -view_cells_use_kd_pvs+ -af_use_kd_pvs+"
 
 
@@ -8,6 +8,5 @@
 VIEWCELLS=../data/PowerPlant/powerplant-seq-viewcells.xml.gz
 
-PREFIX=../work/plots/osp-powerplant-1e5
-
+PREFIX=../work/plots/osp-powerplant-SG08
 
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2602)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2608)
@@ -5,5 +5,5 @@
 TEMPLATE = app
 
-#CONFIG -= qt
+CONFIG -= qt
 
 TARGET = preprocessor