Index: /GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 2609)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 2610)
@@ -5,4 +5,5 @@
 #include <stdlib.h>
 #include <iostream>
+
 #include <xercesc/util/PlatformUtils.hpp>
 
@@ -20,4 +21,5 @@
 #include <xercesc/sax/SAXParseException.hpp>
 #include <xercesc/sax/SAXException.hpp>
+
 
 #include "X3dParser.h"
@@ -102,7 +104,7 @@
 X3dParseHandlers::~X3dParseHandlers()
 {
-	assert(mTransformations.empty());
-	if (0 && !mTransformations.empty())
-		cout << "error: transformation stack size: " << (int)mTransformations.size() << endl;
+  //  assert(mTransformations.empty());
+  if (0 && !mTransformations.empty())
+	cout << "error: transformation stack size: " << (int)mTransformations.size() << endl;
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SceneGraph.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SceneGraph.h	(revision 2609)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SceneGraph.h	(revision 2610)
@@ -36,4 +36,6 @@
 	virtual bool IsLeaf() const { return false; }
 	virtual void UpdateBox();
+
+	~SceneGraphInterior();
 
 //protected:
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SceneGraph.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SceneGraph.cpp	(revision 2609)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SceneGraph.cpp	(revision 2610)
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2609)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2610)
@@ -1244,4 +1244,5 @@
 	}
 
+	
 	if (rays.size() > 10000) 
 	{
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2608)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 2610)
@@ -54,5 +54,5 @@
 	useGlDebugger false
 # 0 = INTERNAL 	1 = MLRT 2 = HAVRAN
-	rayCastMethod 2
+	rayCastMethod 1
 	
 #	type sampling
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2608)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 2610)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 17. I 17:18:38 2008
+# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 17. I 22:17:44 2008
 # Project:  preprocessor.pro
 # Template: app
@@ -71,4 +71,7 @@
 		C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf \
 		C:\Qt\4.1.2\mkspecs\features\default_post.prf \
+		C:\Qt\4.1.2\mkspecs\features\qt.prf \
+		C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf \
+		C:\Qt\4.1.2\mkspecs\features\moc.prf \
 		C:\Qt\4.1.2\mkspecs\features\win32\thread.prf \
 		C:\Qt\4.1.2\mkspecs\features\warn_off.prf \
@@ -89,4 +92,7 @@
 C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf:
 C:\Qt\4.1.2\mkspecs\features\default_post.prf:
+C:\Qt\4.1.2\mkspecs\features\qt.prf:
+C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf:
+C:\Qt\4.1.2\mkspecs\features\moc.prf:
 C:\Qt\4.1.2\mkspecs\features\win32\thread.prf:
 C:\Qt\4.1.2\mkspecs\features\warn_off.prf:
@@ -110,4 +116,16 @@
 distclean: release-distclean debug-distclean FORCE
 	-$(DEL_FILE) Makefile
+
+release-mocclean: $(MAKEFILE).Release
+	$(MAKE) -f $(MAKEFILE).Release mocclean
+debug-mocclean: $(MAKEFILE).Debug
+	$(MAKE) -f $(MAKEFILE).Debug mocclean
+mocclean: release-mocclean debug-mocclean
+
+release-mocables: $(MAKEFILE).Release
+	$(MAKE) -f $(MAKEFILE).Release mocables
+debug-mocables: $(MAKEFILE).Debug
+	$(MAKE) -f $(MAKEFILE).Debug mocables
+mocables: release-mocables debug-mocables
 FORCE:
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2608)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2610)
@@ -299,20 +299,21 @@
 	pt = new QtPreprocessorThread(preprocessor);	
 	
-	if (0 && preprocessor->mUseGlRenderer && (importRandomViewCells || frames))
-	{
+	if (preprocessor->mUseGlRenderer && (importRandomViewCells || frames))
+
+	  {
 		QGLFormat f;
 		f.setStencil(true);
 		QGLFormat::setDefaultFormat(f);
-
 		// NOTE: render texture should be power of 2 and square
 		// renderer must be initialised
 		// $$matt
 		preprocessor->renderer = 
-			new QtGlRendererBuffer(512, 512,
-			preprocessor->mSceneGraph,
-			preprocessor->mViewCellsManager,
-			preprocessor->mKdTree);
-	}
-
+		  new QtGlRendererBuffer(512, 512,
+								 preprocessor->mSceneGraph,
+								 preprocessor->mViewCellsManager,
+								 preprocessor->mKdTree);
+		
+	  }
+	
 	if (preprocessor->mUseGlRenderer || preprocessor->mUseGlDebugger)
 	{
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 2593)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/CombinedPreprocessor.cpp	(revision 2610)
@@ -149,5 +149,7 @@
 	  
 	  if (renderer) {
+		cout<<"Evaluating render error"<<endl;
 		ComputeRenderError();
+		cout<<"Evaluating render error"<<endl;
 	  }
 	}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/havran/configh.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/havran/configh.h	(revision 2608)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/havran/configh.h	(revision 2610)
@@ -14,4 +14,5 @@
 #define __CONFIGH_H__
 
+
 #if defined(_MSC_VER)
 // use perftimer only on msvc
@@ -19,5 +20,5 @@
 #define __SSE__
 // If we support the use of SSE instructions for ray shooting
-#define _USE_HAVRAN_SSE
+//#define _USE_HAVRAN_SSE
 #endif
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel	(revision 2607)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_pixel	(revision 2610)
@@ -3,5 +3,6 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -samples_per_pass=500000 -samples_per_evaluation=10000000 -total_samples=500000000"
+#COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -samples_per_pass=500000 -samples_per_evaluation=10000000 -total_samples=500000000 -preprocessor_pvs_rendererror_samples=10000 -preprocessor_evaluatePixelError+"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_pass=1000000 -samples_per_evaluation=2000000 -total_samples=500000000 -preprocessor_pvs_rendererror_samples=10000 -preprocessor_evaluatePixelError+"
 
 #SCENE="../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d;../data/vienna/vienna-roads.x3d"
@@ -34,5 +35,5 @@
 #VIEWCELLS=../data/vienna/vienna-seq-viewcells-20000.xml.gz
 
-PREFIX=../work/plots/osp-PIXEL3-1e5
+PREFIX=../work/plots/osp-vienna-SG08-PIXEL
 
 #SCENE=../data/atlanta/atlanta2.x3d
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_arena
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_arena	(revision 2607)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SG08/run_test_arena	(revision 2610)
@@ -2,5 +2,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -total_samples=500000000"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -preprocessor_detect_empty_viewspace+ -total_samples=1000000000"
 
 
@@ -8,5 +8,5 @@
 VIEWCELLS=../data/Arena/viewcells-5000.xml.gz
 
-PREFIX=../work/plots/osp-arena-SG08
+PREFIX=../work/plots/osp-arena-SG08a
 
 # $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
@@ -18,14 +18,14 @@
 # # n - no origin mutation, q=2, reverse samples
 
-# $COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-# -preprocessor_visibility_file=$PREFIX-r-reference.xml \
-# -view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
-# -preprocessor_histogram_file=$PREFIX-r-reference.hlog
+$COMMAND -preprocessor=sampling -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+-preprocessor_visibility_file=$PREFIX-r-reference.xml \
+-view_cells_filter_max_size=1 -preprocessor_stats=$PREFIX-r-reference.log \
+-preprocessor_histogram_file=$PREFIX-r-reference.hlog
 
-# $COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
-#  -rss_distributions=direction -view_cells_filter_max_size=1 \
-#  -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
-#  -preprocessor_stats=$PREFIX-r-reference-global.log \
-#  -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
+$COMMAND -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+ -rss_distributions=direction -view_cells_filter_max_size=1 \
+ -preprocessor_visibility_file=$PREFIX-r-reference-global.xml \
+ -preprocessor_stats=$PREFIX-r-reference-global.log \
+ -preprocessor_histogram_file=$PREFIX-r-reference-global.hlog
 
 # -total_samples=500000000000 -total_time=12208 \
@@ -45,14 +45,14 @@
 # ### selected tests
 
-$COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
--mutation_silhouette_prob=0.5 \
--mutation_reverse_samples_distance=1.0 \
--mutation_radius_origin=1.0 \
--mutation_radius_termination=1.0 \
--mutation_use_unsucc_count_importance- \
--mutation_use_pass_importance- \
--mutation_buffer_size=500000 \
--rss_distributions=mutation+object_direction+spatial \
--preprocessor_stats=$PREFIX-combined-m5-2.log 
+# $COMMAND -preprocessor=combined -scene_filename=$SCENE -view_cells_filename=$VIEWCELLS \
+# -mutation_silhouette_prob=0.5 \
+# -mutation_reverse_samples_distance=1.0 \
+# -mutation_radius_origin=1.0 \
+# -mutation_radius_termination=1.0 \
+# -mutation_use_unsucc_count_importance- \
+# -mutation_use_pass_importance- \
+# -mutation_buffer_size=500000 \
+# -rss_distributions=mutation+object_direction+spatial \
+# -preprocessor_stats=$PREFIX-combined-m5-2.log 
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2608)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 2610)
@@ -5,5 +5,5 @@
 TEMPLATE = app
 
-CONFIG -= qt
+#CONFIG -= qt
 
 TARGET = preprocessor
@@ -28,7 +28,10 @@
 unix:INCLUDEPATH += ../support/src/xerces-c-src_2_7_0/include
 
-INCLUDEPATH += ../src ../src/Timer ../src/QtInterface $$NONGTP/Xerces/xerces/include  $$NONGTP/Zlib/include $$NONGTP/Boost $$NONGTP/Devil/include
+#XERCES = $$NONGTP/Xerces/xerces
+XERCES = $$NONGTP/Xerces/xerces-c_2_8_0
+  
+INCLUDEPATH += ../src ../src/Timer ../src/QtInterface $$XERCES/include  $$NONGTP/Zlib/include $$NONGTP/Boost $$NONGTP/Devil/include
 
-win32:LIBPATH += GL $$NONGTP/Xerces/xerces/lib $$NONGTP/Devil/lib \
+win32:LIBPATH += GL $$XERCES/lib $$NONGTP/Devil/lib \
   $$NONGTP/glut $$NONGTP/Boost/lib $$NONGTP/Zlib/lib 
 
@@ -57,8 +60,10 @@
 CONFIG(release) {
 win32:LIBS += xerces-c_2.lib 
+#win32:LIBS += xerces-c_static_2.lib 
 }
 
 CONFIG(debug) {
 win32:LIBS += xerces-c_2D.lib 
+#win32:LIBS += xerces-c_static_2D.lib 
 }
 